<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\PlanilhaCotacao\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Sup02900EmissaoPlanilhaDeCotacaoController extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $connection;
    protected $environment;
    protected $Sup02900EmissaoPlanilhaDeCotacaoService;
    protected $birtStrategy;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $connection, $environment, $Sup02900EmissaoPlanilhaDeCotacaoService,$birtStrategy)

    {
        $this->reportService  = $reportService;
        $this->entityManager  = $entityManager;
        $this->qr2Strategy    = $qr2Strategy;
        $this->newCode        = $newCode;
        $this->connection     = $connection;
        $this->environment    = $environment;
        $this->Sup02900EmissaoPlanilhaDeCotacaoService = $Sup02900EmissaoPlanilhaDeCotacaoService;
        $this->birtStrategy       = $birtStrategy;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
                  
        $row = $request->getRow();
        
        $cdfilial = $this->environment->getCdFilial();
        
        $row["P_CDFILIAL"] = $this->Sup02900EmissaoPlanilhaDeCotacaoService->getCdFilial($cdfilial);
       

        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
                        
        $this->stNomeRel = $this->getReportName($row);
  
        
        
        
        //Criação da lista
                    //cria L_cdregiao
        if($row['L_CDREGIAO']=='T'){
            
            
            $row['L_CDREGIAO'] = $this->retornaRegiao();
           
        }
        
        $row['L_CDREGIAO']=$this->criarListaValores($row['L_CDREGIAO']);
            //cria lista de fornecedor
            if($row['L_CDFORNECED']=='T'){
             
                $row['L_CDFORNECED']=$this->retornaFornecedores($row);
            }
            $row['L_CDFORNECED']=$this->criarListaValores($row['L_CDFORNECED']);
            

        //Valor do pramentro de NRORG
        $row['P_NRORG'] = $this->environment->getNrorgTrab();
            
        
        $this->reportMapping[$this->stNomeRel] =
        
          array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    "P_DTINICABE"       => "P_DTINICABE",
                    "P_DTFINCABE"       => "P_DTFINCABE",
                    "L_CDFORNECED"      => "L_CDFORNECED",
                    "L_CDREGIAO"        => "L_CDREGIAO",
                    "P_DTINI"           => "P_DTINI",
                    "P_DTFIN"           => "P_DTFIN",
                    "P_CDPRODINI"       => "P_CDINI",
                    "P_CDPRODFIN"       => "P_CDFIN",
                    "P_CDFILIAL"        => "P_CDFILIAL",
                    "P_NRORG"           => "P_NRORG",
                    "CDPICTPROD"        =>"P_CDPICTPROD"
                ),
            );
            
            
            
    }
    //insere lista no banco
    public function insertLista($nrlista,$cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        
    }
    
    //cria lista de valores recebendo string como parametro
    public function criarListaValores($valores){
       
            $this->entityManager->beginTransaction();
            $lista = explode('_',$valores);
            $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);
            try{
                foreach($lista as $key){
                    $this->insertLista($nrlista, $key);
                }
                $this->entityManager->commit();
                return $nrlista;
            } catch(\Exception $e){
                $this->entityManager->rollback();
                throw $e;
            }
        
    }
    private function insereLista($nrlista, $filiserv) {
		$rows = array();
		foreach($filiserv as $filialservico){
			array_push($rows,
				array(
					"NRLISTA" 	=> $nrlista,
					"CDLISTA" 	=> $filialservico,
					"__is_new"  => true
				)
			);
		}
		$dataSet = new DataSet(null, $rows);
		$request = new DTO\Request\DataSet($dataSet, '', '', '');
		$rowsToSave = $this->crudService->getRowsToSave($request, 'lista');
		$this->crudService->save('lista', $rowsToSave);
	}
	
	//retorna array de regiões
     public function retornaRegiao(){
         $sql = "SELECT CDREGIAO FROM REGIAO";

        try {
            $regiao = $this->entityManager->getConnection()->fetchAll($sql);
            return implode('_', array_column($regiao, 'CDREGIAO'));
        } catch (\Exception $e) {
            throw $e;
        }
     }
     
     //retorna array de fornecedores
    public function retornaFornecedores(){
         $sql = "SELECT CDFORNECED FROM FORNECEDOR";

        try {
            $fornecedor = $this->entityManager->getConnection()->fetchAll($sql);
            return implode('_', array_column($fornecedor, 'CDFORNECED'));
        } catch (\Exception $e) {
            throw $e;
        }
     }
    
    
    
    
}
