<?php
namespace Teknisa\SUP\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Teknisa\SUP\Util\SupUtilities;

class TrackingAFs extends \Zeedhi\Framework\Controller\Report {
  
  protected $birtStrategy;
  protected $supUtilities;

  public function __construct(ReportService $reportService, $birtStrategy, SupUtilities $supUtilities){
    parent::__construct($reportService);
    $this->birtStrategy = $birtStrategy;
    $this->supUtilities = $supUtilities;
  }

  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $this->birtStrategy->setReportFormat($row['REPORT_EXTENSION']);
  }
  

  protected $reportMapping = array (
    'trackingAFs' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        'CDREGIAO'               => 'P_CDREGIAO',
        'CDFORNECED'             => 'P_CDFORNECED',
        'CDCOMPRADOR'            => 'P_CDCOMPRADOR',
        'DTINIVALITM'            => 'P_DTINIVALITM',
        'DTFINVALITM'            => 'P_DTFINVALITM',
        'CDPRODINI'              => 'P_CDPRODINI',
        'CDPRODFIN'              => 'P_CDPRODFIN',
        'CDMARCA'                => 'P_CDMARCA',
        'DTINIVALANT'            => 'P_DTINIVALANT',
        'DTFINVALANT'            => 'P_DTFINVALANT',
        'PARAMMELHORPRECO'       => 'P_MELHORPRECO',
        'CDFILIAL'               => 'P_CDFILIAL',
        "IDVERIFICAVRIT"         => 'P_IDVERIFICAVRIT',
        'PARAMCOMPPRECO'         => 'P_IDTPCOMPARA',
        'NRORG'                  => 'P_NRORG',
        'EXIBE'                  => 'P_EXIBE',
        'NMREGIAOFORMAT'         => 'P_NMREGIAO',
        'NMPRODINIFORMAT'        => 'P_NMPRODINI',
        'NMPRODFINFORMAT'        => 'P_NMPRODFIN',
        'TOTALIZADOR'            => 'P_TOTALIZADOR',
        'EXIBEMARCA'             => 'EXIBEMARCA',
        'EXIBEQTCOMPRAR'         => 'EXIBEQTCOMPRAR',  
        'EXIBEVRANTERIOR'        => 'EXIBEVRANTERIOR',
        'EXIBEVRTOTALANTERIOR'   => 'EXIBEVRTOTALANTERIOR',
        'EXIBETOTALATUAL'        => 'EXIBETOTALATUAL',
        'EXIBEVARIACAO'          => 'EXIBEVARIACAO',
        'EXIBEVRECO'             => 'EXIBEVRECO',
        'EXIBETOTALECO'          => 'EXIBETOTALECO',
        'EXIBETOTALOBJ'          => 'EXIBETOTALOBJ',
        'EXIBEVARIACAONEG'       => 'EXIBEVARIACAONEG',
        'EXIBETOTALNEG'          => 'EXIBETOTALNEG'
      ),
    ),
  );

}